Option Explicit
'On Error Resume Next

'' BOM SNMPݒڍsc[
'' Copyright (C) 2022 SAY Technologies, Inc. All rights reserved.
'' Ver 8.0.0.3
'' ŏIXVF2022/3/9

' BOM8 
' $(INST7)\Common\snmp\mibs
'      $(INST8)\Common\snmp\\mibs
' $(INST7)\Common\snmp\Config
'      $(DATA8)\Environment\Config\snmp\Config
' ɔzu

'OXNvg̓ǂݍ
Call Include ("Common.vbs")

Dim objFso, objShell, objItem
Dim strCurrUser, strRegKey, strErrMsg
Dim intSvcStatus
Dim strSuffix


'' 萔
Const cBOM_REG_INSTALL_BOM8 = "HKLM\SOFTWARE\SAY Technologies\BOMW8\InstallDir"
Const cBOM_REG_DAT_DIR_BOM8 = "HKLM\SOFTWARE\SAY Technologies\BOMW8\DataDir"
Const cBOM_SNMP_MNG_SERVICE = "BOM8SNMPManageService"
Const cBOM_COMMON_SNMP = "Common\snmp"
Const cBOM_ENVIRON_CONF = "Environment\Config"
Const cBOM_CONFIG = "Config"
Const cBOM_SNMP = "snmp"
Const cBOM_MIBS = "mibs"


'' N`FbN ------------------------------------------------------------
'r`FbN
If IsAlreadyRunning() Then
    fnErrMsgBox "ɎsĂ邽ߏ𒆒f܂B"
    WScript.Quit 1
End IF

'' s[U[J Administrators ɏĂ邩mF
Dim objCom, objUserInfo, objLGroup
Set objCom   = WScript.CreateObject("WinNTSystemInfo")
strCurrUser = Join(Array(objCom.DomainName, objCom.UserName), "/")
Set objUserInfo = GetObject("WinNT://" & strCurrUser & ",user")
Set objLGroup   = GetObject("WinNT://" & objCom.ComputerName & "/Administrators,group")


''  Administrators [U
If Not objLGroup.IsMember(objUserInfo.ADsPath) Then
    fnErrMsgBox "̏͊ǗҌKvłB[U[ɊǗҌ܂B" & vbCrLf & "[U[F" & objCom.UserName
    WScript.Quit 3
End If
Set objUserInfo = Nothing
Set objLGroup = Nothing
Set objCom = Nothing


'' KvȃIuWFNg𐶐 --------------------------------------------------
Set objFso   = WScript.CreateObject("Scripting.FileSystemObject")
Set objShell = WScript.CreateObject("WScript.Shell")


If WScript.Arguments.Count = 0 then
    fnErrMsgBox("in p[^[w肳Ă܂B")
    WScript.Quit 2
End If
Dim bom7_CopyDir
bom7_CopyDir = objFso.GetAbsolutePathName(WScript.Arguments(0))


'' {mF ------------------------------------------------------------------
Dim strMsg
strMsg = "BOM7  SNMP ݒ MIB t@C BOM8 ɃXgA܂B" & vbCrlf
strMsg = strMsg & "̏s BOM8 ݂̌ SNMP ݒ MIB t@C͔j܂B" & vbCrLf
strMsg = strMsg & "s܂H"
If MsgBox(strMsg, vbYesNo Or vbQuestion Or vbDefaultButton2, cAPPTITLE) = vbNo Then
	fnInfMsgBox "XgA𒆎~܂B"
	WScript.Quit 0
End If


Dim dNow
dNow = Now()
strSuffix = "_bk"
strSuffix= strSuffix & Year(dNow)
strSuffix= strSuffix & Right("00" & Month(dNow), 2)
strSuffix= strSuffix & Right("00" & Day(dNow), 2)
strSuffix= strSuffix & Right("00" & Hour(dNow), 2)
strSuffix= strSuffix & Right("00" & Minute(dNow), 2)
strSuffix= strSuffix & Right("00" & Second(dNow), 2)


'' WXgf[^(BOM8InstallDir)擾 ------------------------------------
Dim bom8_InstPath       ' BOM8 CXg[pX
bom8_InstPath = SayGetRegPath(objShell, cBOM_REG_INSTALL_BOM8, strErrMsg)
If Len(bom8_InstPath) < 1 Then
    fnErrMsgBox "BOM8 ̃CXg[悪mFo܂łB" & strErrMsg
    WScript.Quit 4
End If

Dim bom8_SnmpMibsFld    ' BOM8 SNMP MIBpX
bom8_SnmpMibsFld = objFso.BuildPath(objFso.BuildPath(bom8_InstPath, cBOM_COMMON_SNMP), cBOM_MIBS)

'' WXgf[^(BOM8f[^Dir)擾 ------------------------------------
Dim bom8_DataPath       ' BOM8 f[^pX
bom8_DataPath = SayGetRegPath(objShell, cBOM_REG_DAT_DIR_BOM8, strErrMsg)
If Len(bom8_DataPath) < 1 Then
    fnErrMsgBox "BOM8 ̃f[^i[悪mFo܂łB" & strErrMsg
    WScript.Quit 4
End If

Dim bom8_ConfigRoot     ' BOM8 ݒpX
bom8_ConfigRoot = objFso.BuildPath(bom8_DataPath, cBOM_ENVIRON_CONF)
Dim bom8_SnmpRoot       ' BOM8 SNMP pX
bom8_snmpRoot = objFso.BuildPath(bom8_ConfigRoot, cBOM_SNMP)
Dim bom8_SnmpConfigFld  ' BOM8 SNMP ݒpX
bom8_SnmpConfigFld = objFso.BuildPath(bom8_snmpRoot, cBOM_CONFIG)


Dim snmpConfigFld       ' BOM7 SNMP ݒpX
snmpConfigFld = objFso.BuildPath(bom7_CopyDir, cBOM_CONFIG)

Dim snmpMibsFld         ' BOM7 SNMP MIBpX
snmpMibsFld = objFso.BuildPath(bom7_CopyDir, cBOM_MIBS)


''Rs[Ώۃ`FbN ---------------------------------------------------------
'' ڍsΏ(tH_[)̃pXmF
If Not objFso.FolderExists(snmpConfigFld) And Not objFso.FolderExists(snmpMibsFld) Then
    fnErrMsgBox "ڍsΏۂ̃tH_[܂łB" & vbCrLf & "[" & snmpConfigFld & "]" & vbCrLf & "[" & snmpMibsFld & "]"
    WScript.Quit 5
End If


'' ݒtH_[̓ ------------------------------------------------------
IF objFso.FolderExists(snmpConfigFld) Then
    If objFso.FolderExists(bom8_SnmpConfigFld) Then
        If Not SaySyncDirs(objShell, bom8_SnmpConfigFld, bom8_SnmpConfigFld & strSuffix, strErrMsg) Then
            fnErrMsgBox "obNAbvs܂B(" & bom8_SnmpConfigFld & ")" & strErrMsg
            WScript.Quit 6
        End If
    End If

    If Not SaySyncDirs(objShell, snmpConfigFld, bom8_SnmpConfigFld, strErrMsg) Then
        fnErrMsgBox "SNMP ݒtH_[̃Rs[Ɏs܂B" & strErrMsg
        WScript.Quit 6
    End If
End If

On Error Resume Next
Err.Clear

'' Xg̃l[
Dim oldFile
oldFile = objFso.BuildPath(bom8_SnmpConfigFld, "FilterWhite.txt")
If objFso.FileExists(oldFile) Then
    Set objItem = objFso.GetFile(oldFile)
    objItem.Name = "FilterAllow.txt"
    If Err.Number <> 0 Then
        fnErrMsgBox "Xg̖̕ύXɎs܂B[" & Err.Description & "]"
        WScript.Quit 6
    End If
End If
Set objItem = Nothing

'' ۃXg̃l[
oldFile = objFso.BuildPath(bom8_SnmpConfigFld, "FilterBlack.txt")
If objFso.FileExists(oldFile) Then
    Set objItem = objFso.GetFile(oldFile)
    objItem.Name = "FilterDeny.txt"
    If Err.Number <> 0 Then
        fnErrMsgBox "ۃXg̖̕ύXɎs܂B[" & Err.Description & "]"
        WScript.Quit 6
    End If
End If
Set objItem = Nothing
On Error Goto 0


'' mibstH_̓ --------------------------------------------------------
IF objFso.FolderExists(snmpMibsFld) Then
    If objFso.FolderExists(bom8_SnmpMibsFld) Then
        If Not SaySyncDirs(objShell, bom8_SnmpMibsFld, bom8_SnmpMibsFld & strSuffix, strErrMsg) Then
            fnErrMsgBox "obNAbvs܂B(" & bom8_SnmpMibsFld & ")" & strErrMsg
            WScript.Quit 7
        End If
    End If

    If Not SaySyncDirs(objShell, snmpMibsFld, bom8_SnmpMibsFld, strErrMsg) Then
        fnErrMsgBox "MIB tH_[̃Rs[Ɏs܂B" & strErrMsg
        WScript.Quit 7
    End If
End If


'' T[rX̊mF ------------------------------------------------------------
intSvcStatus = SayServiceState(cBOM_SNMP_MNG_SERVICE)
If intSvcStatus = 1 Then
	' T[rX̍ċN
	If Not SayServiceCtl(objShell, "stop", cBOM_SNMP_MNG_SERVICE, strErrMsg) Then
	    fnErrMsgBox "BOM8 SNMP }l[W[̒~Ɏs܂B" & strErrMsg
	    WScript.Quit 8
    ElseIf Not SayServiceCtl(objShell, "start", cBOM_SNMP_MNG_SERVICE, strErrMsg) Then
		fnErrMsgBox "BOM8 SNMP }l[W[̊JnɎs܂B" & strErrMsg
		WScript.Quit 8
	End If
End If


Set objFso = Nothing
Set objShell = Nothing
Set objCom = Nothing

fnInfMsgBox "XgA܂B"
WScript.Quit 0



' =============================================================================
'OvbsǍނ߂̊֐
Public Sub Include(ByVal strFileName)

    Dim objFso, objFile
    Dim strFilePath

    Set objFso = WScript.CreateObject("Scripting.FileSystemObject")

    strFilePath = objFso.BuildPath(objFSO.GetFile(WScript.ScriptFullName).ParentFolder, strFileName)
    Set objFile = objFso.OpenTextFile(strFilePath, 1, False)

    ExecuteGlobal objFile.ReadAll()
    objFile.Close()

    Set objFile = Nothing
    Set objFso = Nothing
End Sub


' WXgf[^擾
Function SayGetRegPath(ByRef iShl, ByVal iRegKey, ByRef oErrDetail)
    Dim resultData

    oErrDetail = ""
    On Error Resume Next
    Err.Clear
    resultData = CStr(iShl.RegRead(iRegKey))
    On Error GoTo 0

    If Err.Number <> 0 Then
        oErrDetail = "[" & Err.Description & "]"
        resultData = ""
    ElseIf Len(resultData) < 1 Then
        resultData = ""
    End If

    SayGetRegPath = resultData
End Function


' fBNg
Function SaySyncDirs(ByRef iShl, ByVal iSrcDir, ByVal iDstDir, ByRef oMsg)
    Const cHIDDEN_WINDOW = 0
    Const cWAIT_EXIT = True
    Dim strCmdLine
    Dim booResult, intExitCode

    '' ϐ
    oMsg = ""
    booResult = False
    strCmdLine = Join(Array("robocopy", """" & iSrcDir & """", """" & iDstDir & """", "/MIR", "/R:0", "/W:0"), " ")

    '' fBNg
    On Error Resume Next
    Err.Clear
    intExitCode = iShl.Run(strCmdLine, cHIDDEN_WINDOW, cWAIT_EXIT)
    On Error Goto 0

    '' G[`FbN
    If Err.Number <> 0 Then
        oMsg = "[" & Err.Description & "]"
    ElseIf intExitCode > 8 Then
        ''' EXITR[h 0`8 ͐IB
        ' https://docs.microsoft.com/ja-jp/windows-server/administration/windows-commands/robocopy#exit-return-codes
        oMsg = "[EXIT CODE:" & CStr(intExitCode) & "]"
    Else
        booResult = True
    End If

    SaySyncDirs = booResult
End Function


' ȈՃT[rXRg[
Function SayServiceCtl(ByRef iShl, ByVal iCmd, ByVal iSvcName, ByRef oMsg)
    Const cHIDDEN_WINDOW = 0
    Const cWAIT_EXIT = True
    Dim strCmdLine
    Dim booResult, intExitCode

    '' ϐ
    oMsg = ""
    booResult = False
    strCmdLine = Join(Array("net", iCmd, iSvcName), " ")

    '' R}hs
    On Error Resume Next
    Err.Clear
    intExitCode = iShl.Run(strCmdLine, cHIDDEN_WINDOW, cWAIT_EXIT)
    On Error Goto 0

    '' G[`FbN
    If Err.Number <> 0 Then
        oMsg = "[" & Err.Description & "]"
    ElseIf intExitCode <> 0 Then
        oMsg = "[EXIT CODE:" & CStr(intExitCode) & "]"
    Else
        booResult = True
    End If

    SayServiceCtl = booResult
End Function
